##############################
#
# COPYRIGHT (c) 2007 shagon
# COMPILER:PythonWin
# DEBUG ON Series 60 C++ SDKs
# TESTED ON NOKIA6670
# DATE:Sep 29th,2007
#
##############################
# -*- coding:utf-8 -*- 
import e32
import appuifw
import audio
import time

fileroot='e:\\system\\apps\\VoiceClock\\sounds\\'
running=0
modeset=60

def exit():
    global running
    if running==1:
        appuifw.note('请挂机后台运行'.decode('utf8'),'error')
        background()
    else:        
        manuexit()   
appuifw.app.exit_key_handler=exit
def manuexit():
    global running
    if appuifw.query('确定退出'.decode('utf8'),'query'):
        running=0        
        appuifw.app.set_exit()
    else:
        background()
def background():
    appuifw.app.screen='large'
    appuifw.app.title='俊音报时'.decode("utf-8")
    appuifw.app.body =appuifw.Text('\n\n\n     俊音报时(shagon出品) \n－－－－－－－－－－－－－\n   运行后按挂机键后台隐藏\n－－－－－－－－－－－－－ \n\n\n                V i s i t  |  \n                www.cnpda.com.cn\n                           | 4  More'.decode("utf-8"))
    appuifw.app.menu =[
                    (
                      ('用户设定'.decode("utf-8")),
                      (
                          ('整点报时'.decode("utf-8"),oalarm),
                          ('半点报时'.decode("utf-8"),halfalarm)
                                                               )),   
                      ('开始运行'.decode("utf-8"),voicealarm),
                      ('使用帮助'.decode("utf-8"),helpinfo),
                      ('关于作者'.decode("utf-8"),about_info),
                      ('退出软件'.decode("utf-8"),manuexit)
                                                                                       ]  
def about_info():
    appuifw.note('shagon作品\nwww.cnpda.com.cn\nCNPDA编程组\n2007.09.29'.decode("utf-8"), "info")
def helpinfo():
    appuifw.app.body =appuifw.Text('帮助:\n      在用户设定中可选择整点或半点报时。默认为整点报时。\n\n      用户可以选择用自己的声音文件。只要将安装目录下sounds文件夹里的文件用同名文件替换。\n      例如你安装在e盘，则具体路径是：e:\\system\\apps\\VoiceClock\\sounds。'.decode("utf-8"))
def halfalarm():
    global modeset
    modeset=30   
    appuifw.note('已设定为\n半点报时'.decode("utf-8"), "conf")
def oalarm():
    global modeset
    modeset=60
    appuifw.note('已设定为\n整点报时'.decode("utf-8"), "conf")
    
def voicealarm():
    global running
    global modeset
    global fileroot
    appuifw.note('开始运行\n挂机后台隐藏'.decode("utf-8"), "conf")
    running=1
    delay=e32.Ao_timer()
    playdelay=e32.Ao_timer()    
    current_time=time.localtime(time.time())
    current_hour=current_time.tm_hour
    current_minute=current_time.tm_min
    current_second=current_time.tm_sec
    if current_minute>=30:
        alarmdelay=3600-current_minute*60-current_second
        current_hour+=1
        if current_hour==24:
            current_hour=0        
        halfalarm=0
    else:
        alarmdelay=1800-current_minute*60-current_second
        halfalarm=1        
    delay.after(alarmdelay)
    
    while running:
        filename1=fileroot+'head.mp3'
        filename2=fileroot
        if 0<current_hour<=6: filename2=filename2+'dawn.mp3'
        elif 6<current_hour<=12: filename2=filename2+'morning.mp3'
        elif 12<current_hour<=18: filename2=filename2+'afternoon.mp3'
        else: filename2=filename2+'night.mp3'
        alarm_hour=current_hour%12
        if alarm_hour==0: alarm_hour=12
        if modeset==30 and halfalarm:
            filename3=fileroot+str(alarm_hour)+'half.mp3'
        else:
            filename3=fileroot+str(alarm_hour)+'.mp3'
            
        voice=audio.Sound.open(filename1)
        voice.play()
        while voice.state()==audio.EPlaying:
            playdelay.after(0.01)
        voice.stop()
        voice.close()
        voice=audio.Sound.open(filename2)
        voice.play()
        while voice.state()==audio.EPlaying:
            playdelay.after(0.01)
        voice.stop()
        voice.close()
        voice=audio.Sound.open(filename3)
        voice.play()
        while voice.state()==audio.EPlaying:
            playdelay.after(0.01)
        voice.stop()
        voice.close()
        
        for i in range(modeset/30):
            halfalarm=(halfalarm+1)%2
            if halfalarm==0:
                current_hour+=1
                if current_hour==24:
                    current_hour=0 
            new_time=time.localtime(time.time())
            new_hour=new_time.tm_hour
            new_minute=new_time.tm_min
            new_second=new_time.tm_sec
            if halfalarm==0:
                temp=current_hour*3600
            else:
                temp=current_hour*3600+1800            
            alarmdelay=temp-new_hour*3600-new_minute*60-new_second
            delay.after(alarmdelay)
app_lock=e32.Ao_lock()
background()
app_lock.wait()